/**
 * @file OptionParser.h
 * @brief եιʸ
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2008-05-01
 *
 * Copyright (C) 2004-2008, Yashiro Takeshi
 *
 *   BSlide ˤäΤŬ˲Ѥ
 */

#ifndef DEFINE_H_OPTIONPARSER
#define DEFINE_H_OPTIONPARSER

#include <string>
#include <map>
#include <basic.h>
#include <tlang.h>

class OptionParser {
  
  typedef enum {
    START_OF_LINE, PERCENT_PARSED, COLON_PARSED, NONOPTION_LINE
  } ParserState;

private:
  std::map<std::string, std::string> opts;
  ParserState currentState;
  std::string keytmp;
  std::string linestack;
  W currentLang;
  W n;

public:

  OptionParser() 
    : currentState(START_OF_LINE), n(0), currentLang(TSC_SYS) {}
  virtual ~OptionParser() {}
  
  const std::string& getOption(const std::string& key) const {
    std::map<std::string, std::string>::const_iterator p;
    p = opts.find(key);
    if (p != opts.end()){
      return p->second;
    }
    return "";
  }
  
  void putChar(TC ch);
};

#endif // DEFINE_H_OPTIONPARSER
