/**
 * @file main.cc
 * @brief ȥ饤 ᥤ
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2008-05-01
 *
 * Copyright (C) 2008, Yashiro Takeshi
 */

#include <basic.h>
#include <bstdio.h>
#include <btron/libapp.h>
#include <btron/vobj.h>
#include <btron/bsocket.h>
#include <btron/taskcomm.h>
#include <btron/file.h>
#include <tstring.h>
#include <bstring.h>
#include <tcode.h>
#include <keycode.h>
#include <string>
#include "tcsliteral.h"
#include "BufferedReader.h"
#include "OptionParser.h"
#include "Exception.h"
#include "synergy.h"

extern WEVENT wevt;
extern int inet_pton(int, const char*, void*);

extern SynergyTaskInfo* synergy_start(const char *server,
                                      const char *name);
extern void synergy_stop(SynergyTaskInfo* info);

/**
 * Synergy³
 */
struct SynergyConfig {
  std::string server;
  std::string name;
};


static WINFOREC winfo[2];
static W mid = -1;

static TC m_finish[] = {TCS_MENU_FINISH};
static TC m_line[] = {MC_LINE, TNULL};
static MENUITEM mitems[] = {
  {0, 0, 0, 0, m_finish},
  {0, 0, 0, 0, m_line},
  {0, 0, 0, 0, NULL},
  {0, 0, 0, 0, NULL},
};
static const int n_mitems = sizeof(mitems) / sizeof(MENUITEM);

static SynergyTaskInfo *synergy_info = NULL;


/**
 * 󥯤μ
 *
 * MESSAGE¤Τ顢ԽоݤȤʤեΥ󥯤ޤ
 *
 * @param msg MESSAGE¤
 * @return msgLINK¤ΤؤΥݥ
 */
static LINK* getTargetLink(MESSAGE* msg)
{
  switch (msg->msg_type){
  case EXECREQ:
    if ((((M_EXECREQ*)msg)->mode & 0x0002) != 0) {
      // ȵưΤǧᡢʪưϰ۾ｪλ
      oend_prc(((M_EXECREQ*)msg)->vid, NULL, 0);
      return 0;
    }
    return &(((M_EXECREQ*)msg)->lnk);
  case FUSENREQ: // 䵤Υץư
    oend_prc(((M_FUSENREQ*)msg)->vid, NULL, 0);
    return 0;
  case DISPREQ: // Ȥɽư
    oend_req(((M_DISPREQ*)msg)->vid, 1);
    return 0;
  case PASTEREQ: // ǡŽߵư
    oend_req(((M_PASTEREQ*)msg)->vid, 1);
    return 0;
  case TADREQ: // ȤTADǡư
    oend_req(((M_TADREQ*)msg)->vid, 1);
    return 0;
  default:
    return 0;
  }
  return 0;
}


void dispError(const TC* errmsg)
{
  sig_buz(0);
  pdsp_msg(const_cast<TC*>(errmsg));
}


static void readSynergyConfig(const LINK* link, SynergyConfig* conf)
{
  W fd, type;

  // եΥץ
  fd = opn_fil(const_cast<LINK*>(link), F_READ, NULL);
  if (fd < 0){
    return;
  }

  // TAD쥳ɤθ
  type = fnd_rec(fd, F_TOPEND, RM_TADDATA, 0, NULL);
  if (type < 0){
    return;
  }

  try {
    // ɤ߹
    BufferedReader reader(fd);
    OptionParser parser;
  
    while (!reader.isEOF()){
      B head[sizeof(LTADSEG)];
      TADSEG *th = reinterpret_cast<TADSEG*>(head);
      LTADSEG *lth = reinterpret_cast<LTADSEG*>(head);

      reader.read((B*)&(th->id), sizeof(th->id));

      if ((th->id & 0xff00) == 0xff00){
        reader.read((B*)&(th->len), sizeof(th->len));
        if (th->len != 0xffff){
          // ̾糧
          reader.skip(th->len);
        }
        else {
          // 顼
          reader.read((B*)&(lth->llen), sizeof(lth->llen));
          reader.skip(lth->llen);
        }
      }
      else {
        // Ĺ
        parser.putChar(th->id);
      }
    }

    conf->server = parser.getOption("server");
    conf->name   = parser.getOption("name");
  }
  catch (FileReadException& e) {}

  cls_fil(fd);
}


static void idle_fn()
{
  if (wevt.s.wid == winfo[0].wid &&
      wevt.s.cmd == W_WORK && (wevt.s.stat & ES_CMD) == 0){
    gset_ptr(PS_SELECT, NULL, (COLOR)-1, (COLOR)-1);
  }
}


void disp_fn(W wno, W mode, RECT* r)
{
  switch (mode){
  case -1: case 0: case 1: case 3:
  case 5:  case 6: case 7: case 9:
    do {
      if (wsta_dsp(winfo[wno].wid, NULL, NULL) == 0)
        break;
      wera_wnd(winfo[wno].wid, NULL);
    } while (wend_dsp(winfo[wno].wid) > 0);
    break;
  default:
    break;
  }
  return;
}


W finish_fn(W wno, W mode)
{
  return 1; // λǤ뤳Ȥ򳰤
}


static W select_menu(W sel)
{
  switch (sel >> 8) {
  case 0:
    return -1; // λ
  case 2:
    wexe_dmn(sel);
    return 0;
  case 3:
    oexe_apg(0, sel);
    return 0;
  default:
    return 0;
  }
}


W menu_fn()
{
  wget_dmn(&(mitems[n_mitems-2].ptr));
  mset_itm(mid, n_mitems-2, &(mitems[n_mitems-2]));
  oget_men(0, NULL, &(mitems[n_mitems-1].ptr), NULL, NULL);
  mset_itm(mid, n_mitems-1, &(mitems[n_mitems-1]));

  W sel = msel_men(mid, wevt.s.pos);
  if (sel == 0){
    return 0;
  }
  return select_menu(sel);
}


W key_fn()
{
  if (wevt.s.stat & ES_CMD){
    W i = mfnd_key(mid, wevt.s.wid);
    if (i > 0){
      return select_menu(i);
    }
  }
  return 0;
}


W msg_fn(MESSAGE* msg)
{
  MESSAGE msgbody;
  W err;

  err = rcv_msg(MM_ALL, &msgbody, sizeof(MESSAGE), WAIT|CLR);
  if (err < 0) {
    clr_msg(MM_ALL, MM_ALL);
    return 0;
  }
  if (err > 0 || msgbody.msg_type != MS_TYPE7 
      || msgbody.msg_size != sizeof(W)) {
    return 0;
  }
  
  W req = *reinterpret_cast<W*>(&(msgbody.msg_body));
  switch (req) {
  case 1: // λꥯ
    return 1;
  default:
    return 0;
  }
}


static WFUNCREC wfunc = {
  NULL,        // bgfn
  idle_fn,     // idlefn
  msg_fn,      // msgfn
  menu_fn,     // menufn
  disp_fn,     // dspfn
  NULL,        // stsfn
  key_fn,      // keyfn
  NULL,        // presfn
  finish_fn,   // finfn
  NULL,        // pastefn
  NULL,        // respfn
  NULL,        // scrlfn
  NULL,        // devfn
  NULL,        // vobjfn 
};


extern "C" W MAIN(MESSAGE* msg)
{
  SynergyConfig conf;
  RECT r = {{ -200, -200, -100, -100 }};
  TC wintitle[] = {TCS_WINDOWTITLE};
  W err;

  synergy_info = NULL;

  pdsp_msg(NULL);
  dopn_dat(NULL);
  getscreen();
  initstdpnl();

  LINK *link = getTargetLink(msg);
  if (link == NULL){
    dispError((TC[]){EMSG_FNSPEC});
    oend_prc(((M_EXECREQ*)msg)->vid, NULL, 0);
    goto err_ret0;
  }

  readSynergyConfig(link, &conf);
  if (conf.server.empty()) {
    dispError((TC[]){EMSG_CONFSERVER});
    oend_prc(((M_EXECREQ*)msg)->vid, NULL, 0);
    goto err_ret0;
  }

  err = wopn_wnd(WA_STD, 0, &r, NULL, 2, wintitle, NULL, NULL);
  if (err < 0) {
    dispError((TC[]){EMSG_OPENWIN});
    oend_prc(((M_EXECREQ*)msg)->vid, NULL, 0);
    goto err_ret0;
  }
  winfo[0].wid = err;
  winfo[1].wid = 0;

  err = mcre_men(n_mitems, mitems, NULL);
  if (err < 0) {
    dispError((TC[]){EMSG_OPENMENU});
    oend_prc(((M_EXECREQ*)msg)->vid, NULL, 0);
    goto err_ret1;
  }
  mid = err;

  osta_prc(((M_EXECREQ*)msg)->vid, winfo[0].wid);

  synergy_info = synergy_start(conf.server.c_str(), conf.name.c_str());
  if (synergy_info == NULL) {
    goto err_ret3;
  }

  do {
    err = evt_loop(&wfunc, winfo);
  } while (err == 0);

  synergy_stop(synergy_info);
  synergy_info = NULL;

  // FALLTHROUGH
err_ret3:
  oend_prc(((M_EXECREQ*)msg)->vid, NULL, 0);

err_ret2:
  mdel_men(mid);

err_ret1:
  wcls_wnd(winfo[0].wid, CLR);

err_ret0:
  dcls_dat(0);
  ext_prc(0);
}

