/**
 * @file synergy.h
 * @brief Synergy
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2008-05-01
 *
 * Copyright (C) 2008, Yashiro Takeshi
 */

#ifndef DEFINE_H_SYNERGY
#define DEFINE_H_SYNERGY

#include <basic.h>
#include <btron/bsocket.h>
#include <btron/tf.h>
#include "int.h"

struct SynergyTaskInfo {
  W            lock;
  W            socket;
  W            driver;
  W            task_proto;
  W            task_alive;
  char*        server;
  sockaddr_in* saddr;
  char*        name;
  UINT32       seq;
  TF_CTX       tctx_from;
  TF_CTX       tctx_to;
  bool         handshaked;
  bool         entered;
  bool         cid_mine[2];
  bool         cid_upd[2];
  W            tnum;
  UW           tsize;
};

typedef void SynergyCallback(SynergyTaskInfo*, UINT8*, int);

struct SynProtoMapping {
  const char* key;
  SynergyCallback* val;
};

#endif // DEFINE_H_SYNERGY
